#property indicator_chart_window //   
#property indicator_buffers 5
#property indicator_color1 Magenta // 
#property indicator_color3 Green // . . 
#property indicator_color4 Red // . . 
#property indicator_color5 Blue // MA
//  
extern double Sensitivity=5; //  .  ..
extern int ma_period=5; //  MA
extern int ma_method=0; // 0-SMA, 1-EMA, 2-SMMA, 3-LWMA
extern int applied_price=0; // 0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED
extern int ShowZigZag=1; //  1 -   , 2 -   
extern int ShowChannel=1; //  1 -   , 2 -   
// .
double   ZZpeak[], // 
         ZZtrough[], // 
         ChTop[], // . . 
         ChBot[], // . . 
         MA[]; // MA
//  
double sens; // .  
bool flag;
double tx,px,top,bot;
double h,l;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   sens=Sensitivity*Point; // .  
//---- indicators
   SetIndexBuffer(0,ZZpeak);
   SetIndexEmptyValue(0,0.0);
   SetIndexLabel(0,"Peak");
   
   SetIndexBuffer(1,ZZtrough);
   SetIndexEmptyValue(1,0.0);
   SetIndexLabel(1,"Trough");
   
   if(ShowZigZag>0) {
      SetIndexStyle(0,DRAW_ZIGZAG);
      SetIndexStyle(1,DRAW_ZIGZAG);
     }
   else {      
      SetIndexStyle(0,DRAW_NONE);
      SetIndexStyle(1,DRAW_NONE);
     }

   SetIndexBuffer(2,ChTop);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexLabel(2,"ChTop");

   SetIndexBuffer(3,ChBot);
   SetIndexEmptyValue(3,0.0);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexLabel(3,"ChBot");

   if(ShowChannel>0) {
      SetIndexStyle(2,DRAW_LINE);
      SetIndexStyle(3,DRAW_LINE);
     }
   else {      
      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
     }

   SetIndexBuffer(4,MA);
   SetIndexStyle(4,DRAW_LINE);
   string _ma="MA("+ma_period+") "+ma_method+", "+applied_price;
   SetIndexLabel(4,_ma);

//----
   IndicatorShortName("ZZ@MA"); 

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int ic=IndicatorCounted();
   if(Bars-ic-1>1) ic=reinit();
   int limit=Bars-ic-1; // - 

   for(int i=limit; i>=0; i--) MA[i]=iMA(NULL,0,ma_period,0,ma_method,applied_price, i); 

   for(i=limit; i>0; i--)
     {
      double c=MA[i];
      static int jp,jt; //       
      jp++; jt++;
      //-------------   -------------------------------------------         
      if(flag)                      //  =1,   
        {
         if(l>Low[i]) {l=Low[i]; jt=0;} 
         tx=MathMin(tx,c);
         if(c >= tx+sens)           //        , 
           {
            int sh=ArrayMinimum(Low,jp,i);
            bot=Low[sh];
            if(ShowZigZag==1) ZZtrough[sh]=bot; else ZZtrough[i]=bot;
            if(ShowChannel==1) for(int k=sh; k>i; k--) ChBot[k]=bot;
            px=c;                   
            h=High[i];
            flag=0;                 //   " "
            jp=0;
           }
        }
      //-------------   -----------------------------------------         
      else                          //  =0,   
        {
         if(h<High[i]) {h=High[i]; jp=0;} 
         px=MathMax(px,c);
         if(c <= px-sens)           //        , 
           {
            tx=c;
            sh=ArrayMaximum(High,jt,i);
            top=High[sh];
            if(ShowZigZag==1) ZZpeak[sh]=top; else ZZpeak[i]=top;
            if(ShowChannel==1) for(k=sh; k>i; k--) ChTop[k]=top;
            l=Low[i];
            flag=1;                 //  " "
            jt=0; 
           }
        }
      //--------------------------------------------------------------------
      for(k=0; k<2; k++) {ChTop[i-k]=top; ChBot[i-k]=bot;}
     }
        
   return(0);
  }


// -  
int reinit()
  {
   ArrayInitialize(ZZpeak,0.0);
   ArrayInitialize(ZZtrough,0.0);
   ArrayInitialize(ChTop,0.0);
   ArrayInitialize(ChBot,0.0);
   ArrayInitialize(MA,0.0);
   flag=0; tx=0;px=0;top=0;bot=0;l=0;h=0;
   return(0);
  }

